"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const api_client_1 = require("@ffflorian/api-client");
const api_1 = require("./api");
class LibrariesIO {
    constructor(options) {
        if (typeof options === 'string') {
            options = { apiKey: options };
        }
        this.options = Object.assign({ apiUrl: 'https://libraries.io/api' }, options);
        const requestInjector = config => {
            config.data = Object.assign({}, config.data, { api_key: this.options.apiKey });
            return config;
        };
        // const responseInjector = (response: AxiosResponseWithoutData<LibrariesIOHeaders>) => {
        //   const headers = response.headers;
        //   const contentType = headers['content-type'] ? String(headers['content-type']) : undefined;
        //   const rateLimit = Number(headers['x-ratelimit-limit']);
        //   const rateLimitRemaining = Number(headers['x-ratelimit-remaining']);
        //   const totalResults = headers['total'] ? Number(headers['total']) : undefined;
        //   return {...response, d: 2}
        // }
        this.apiClient = new api_client_1.APIClient({
            apiUrl: this.options.apiUrl,
            requestInjector,
        });
        this.api = {
            github: {
                repository: new api_1.GitHubRepositoryAPI(this.apiClient, this.options),
                user: new api_1.GitHubUserAPI(this.apiClient, this.options),
            },
            platform: new api_1.PlatformAPI(this.apiClient, this.options),
            project: new api_1.ProjectAPI(this.apiClient, this.options),
            user: new api_1.UserAPI(this.apiClient, this.options),
        };
    }
    /*
  
        const contentType = headers['content-type'] ? String(headers['content-type']) : undefined;
        const rateLimit = Number(headers['x-ratelimit-limit']);
        const rateLimitRemaining = Number(headers['x-ratelimit-remaining']);
        const totalResults = headers['total'] ? Number(headers['total']) : undefined;
    */
    /**
     * Set a new API URL.
     * @param newUrl The new API url
     */
    setApiUrl(newUrl) {
        this.apiClient.setApiUrl(newUrl);
    }
    /**
     * Set a new API key.
     * @param apiKey The new API key
     */
    setApiKey(apiKey) {
        this.options.apiKey = apiKey;
    }
}
exports.LibrariesIO = LibrariesIO;
//# sourceMappingURL=LibrariesIO.js.map