"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Endpoints_1 = require("../Endpoints");
const APIBase_1 = require("./APIBase");
class PlatformAPI extends APIBase_1.APIBase {
    constructor(apiClient, options) {
        super(apiClient, options);
    }
    /**
     * Get list of supported package managers.
     * @see https://libraries.io/api#platforms
     * @param options Pagination options
     */
    getPlatforms(options) {
        const endpoint = Endpoints_1.Endpoint.platforms();
        return this.apiClient.requestService.get(endpoint, { data: options });
    }
}
exports.PlatformAPI = PlatformAPI;
//# sourceMappingURL=PlatformAPI.js.map